#include "xsio.h"

#define F_CPU 16000000  

void drawScene() {
    // deseneaza axa verticala
    fb.drawVLine(43, 0, 64);
    fb.drawVLine(42, 0, 64);
    fb.drawVLine(85, 0, 64);
    fb.drawVLine(86, 0, 64);

    // orizontala y  x
    fb.drawHLine(0, 21, 128);
    fb.drawHLine(0, 20, 128);
    fb.drawHLine(0, 41, 128);
    fb.drawHLine(0, 42, 128);

    fb.invert(0);
} 

void setButtons() {
    DDRB &= ~(1 << PB0);
    DDRB &= ~(1 << PB1);
    DDRB &= ~(1 << PB2);
    DDRB &= ~(1 << PB3);
    DDRB &= ~(1 << PB4);

    DDRD &= ~(1 << PD0);
    DDRD &= ~(1 << PD1);
    DDRD &= ~(1 << PD3);
    DDRD &= ~(1 << PD4);
    DDRD &= ~(1 << PD5);

    PORTB |= (1 << PB0);
    PORTB |= (1 << PB1);
    PORTB |= (1 << PB2);
    PORTB |= (1 << PB3);
    PORTB |= (1 << PB4);

    PORTD |= (1 << PD0);
    PORTD |= (1 << PD1);
    PORTD |= (1 << PD3);
    PORTD |= (1 << PD4);
    PORTD |= (1 << PD5);
}

void drawX(int x, int y, int status) {
    int i, p;
    for (i = 0; i < (int)sizeof(bitmapX); ++i) {
        for (p = 0; p < 8; ++p) {
            if ((bitmapX[i] >> p) & 0x1)
                fb.drawPixel(p+x,i+y, status);
        }
    }
}

void drawO(int x, int y, int status) {
    int i, p;
    for (i = 0; i < (int)sizeof(bitmapO); ++i) {
        for (p = 0; p < 8; ++p) {
            if ((bitmapO[i] >> p) & 0x1)
                fb.drawPixel(p+x,i+y, status);
        }
    }
}

void drawPatrat(int x, int y, int status) {
    int i, p;
    for (i = 0; i < (int)sizeof(bitmapPatrat); ++i) {
        for (p = 0; p < 8; ++p) {
            if ((bitmapPatrat[i] >> p) & 0x1)
                fb.drawPixel(p+x,i+y, status);
        }
    }
}
void drawW(int x, int y, int status) {
    int i, p;
    for (i = 0; i < (int)sizeof(bitmapW); ++i) {
        for (p = 0; p < 8; ++p) {
            if ((bitmapW[i] >> p) & 0x1)
                fb.drawPixel(p+x,i+y, status);
        }
    }
}
void drawN(int x, int y, int status) {
    int i, p;
    for (i = 0; i < (int)sizeof(bitmapN); ++i) {
        for (p = 0; p < 8; ++p) {
            if ((bitmapN[i] >> p) & 0x1)
                fb.drawPixel(p+x,i+y, status);
        }
    }
}

// in functie de coordonate, returneaza 
// pozitia in matricea de 3 x 3
int getPosition(int x, int y) {
    if (x == 15) {
        if (y == 3)          return 0;
        else if (y == 25)    return 3;
        else if (y == 47)    return 6;
    }
    if (x == 60) {
        if (y == 3)          return 1;
        else if (y == 25)    return 4;
        else if (y == 47)    return 7;
    }
    if (x == 105) {
        if (y == 3)          return 2;
        else if (y == 25)    return 5;
        else if (y == 47)    return 8;
    }
    return -1;
}

// sterge patratul si deseneaza daca exista in matrice setat
// x-ul sau o-ul
void changePos(){
    drawPatrat(x, y, 0);
    if(matrice[getPosition(x,y)/3][getPosition(x,y) %3] == 1){
        drawX(x, y, 1);
    }
    if(matrice[getPosition(x,y)/3][getPosition(x,y) %3] == 5){
        drawO(x, y, 1);
    }       
}

// verifica facand suma, daca exista pe linie, coloana sau 
// diagonala doar x-uri, sau doar o-uri
int checkWinOrDraw(){
    int win[8];
    int i,j;
    int draw = 0;
    for(i = 0; i < 8; ++i){
        win[i] = 0;
    }
    for (i = 0 ; i < 3; ++i) {
        win[i] = matrice[i][0] + matrice[i][1] + matrice[i][2];
    }
    for (i = 0 ; i < 3; ++i) {
        win[i+3] = matrice[0][i] + matrice[1][i] + matrice[2][i];
    }
    // diagonala
    win[6] = matrice[0][0] + matrice[1][1] + matrice[2][2];
    win[7] = matrice[0][2] + matrice[1][1] + matrice[2][0];

    // verificare suma pentru x(3) sau pentru o(5)
    for (i = 0; i < 8; ++i) {
        if (win[i] == 3) {
            return 1;
        }
        if (win[i] == 15) {
            return 2;
        }           
    }
    // calculeaza remiza
    for(i = 0; i< 3; i++){
        for(j = 0; j < 3; j++){
            draw = draw + matrice[i][j];
        }    
    }
    // atunci cand nu mai e niciun loc in matrice + remiza
    if(draw == 25){
        return 3;
    }
    return 0;  
}

int main(void) {
    x = 60; y = 25; // matratelul mereu incepe pe mijloc
    choise = true; //  se incepe cu x
    win = false;

    setButtons();
    drawScene();

    for(i = 0 ; i < 3; i++){
       for(j = 0 ; j < 3; j++){
            matrice[i][j] = 0;
        }
    }
     while (1) {
        if ((PINB & (1 << PB0)) == 0){ // sus
            // daca butonul ramane apasat, nu se intampla nimic
            while((PINB & (1 << PB0)) == 0);
            changePos();
            // in caz ca se vrea iesirea din cadran se seteaza
            // in directia opusa
            if (y-22 < 3)
                y = 47;
            else y -= 22;
        }else if ((PINB & (1 << PB4)) == 0){ // jos
            while((PINB & (1 << PB4)) == 0);
            changePos();
            if (y+ 22 > 47)
                y = 3;
            else y += 22;
        }else if ((PINB & (1 << PB3)) == 0){ // dreapta
            while((PINB & (1 << PB3)) == 0);
            changePos();
            if (x + 45 > 105)
                x = 15;
            else x += 45;
        }else if ((PINB & (1 << PB2)) == 0){ // stanga
            while((PINB & (1 << PB2)) == 0);
            changePos();
            if (x - 45 < 15)
                x = 105;
            else x -= 45;
        }else if ((PINB & (1 << PB1)) == 0){ // set
            int setxo;
           
            while ((PINB & (1 << PB1)) == 0);
            setxo = getPosition(x, y);
            drawPatrat(x, y, 0);
            
            // este randul X, si nu este nimic la pozitia (x, y)
            if (choise && matrice[setxo/3][setxo % 3] == 0) {
                drawX(x, y, 1);
                // se deseneaza x-ul si se marcheaza in matrice
                matrice[setxo/3][setxo % 3] = 1;
                // urmeaza randul lui 0
                choise = false;
            // este randul lui O si nu e nimic la pozitia (x, y)
            } else if (!choise && matrice[setxo/3][setxo % 3] == 0){
                drawO(x, y, 1);
                // se deseneaza 0-ul si se marcheaza in matrice
                matrice[setxo/3][setxo % 3] = 5;
                // urmeaza randul lui X
                choise = true;
            }
            
            choise?drawO(x,y,1):drawX(x,y,1);
           
            if (checkWinOrDraw() == 1) {
                //afisare caz X WON
                win = true;
                fb.clear();

                drawX(15, 25, 1);
                drawW(50, 25, 1);
                drawO(65, 25, 1);
                drawN(80, 25, 1);

                drawPatrat(x, y, 0);
            }
            if (checkWinOrDraw() == 2) {
                //afisare caz O WON
                win = true;
                fb.clear();

                drawO(15, 25, 1);
                drawW(50, 25, 1);
                drawO(65, 25, 1);
                drawN(80, 25, 1);

                drawPatrat(x, y, 0);
            }
            if(checkWinOrDraw() == 3){
                //afisare caz DRAW
                win = true;
                fb.clear();

                drawN(50, 3, 1);
                drawO(70, 3, 1);

                drawW(50, 25, 1);
                drawO(65, 25, 1);
                drawN(80, 25, 1);
                drawPatrat(x, y, 0);
            }
            x = 60; y = 25;
        } else if ((PIND & (1 << PD3)) == 0){
            // reset
            fb.clear();
            for(i=0;i<3;i++){
                    for(j=0;j<3;j++){
                        matrice[i][j] = 0;
                }
            }
            choise = true;
            drawScene();
            win = false;
            x = 60; y = 25;
        }else {
            if (!win){
                drawPatrat(x, y, 1);
            }
        }
        fb.show();
    }
    return 0;
}
